/*This is from some old source I had lying around
  It converts N64 images to TGA format,
    usually by screwing over the original formatting.
    For instance, instead of indexed anything it produces some scary 32bit images
  Partially this is because nobody seems to support anything but a few random Targa modes,
    but mostly due to my complete lack of interest in doing so myself
    Guess that's probably why nobody supports the majority of TGA's possible format
    Lament.*/

#include <stdio.h>
#include <stdlib.h>
#include "TWINE.h"

/*function declarations*/
unsigned long palette16(unsigned short org);
unsigned long filesize(FILE *in);
int header(FILE *out, int mode);
long lupus(FILE *in, FILE *out, int mode);
unsigned long image(FILE *in, FILE *out);
unsigned short vartrans(unsigned char org);
int TGAheader(FILE* out, unsigned long mode, unsigned short x, unsigned short y, unsigned short attrib);
int TGAfooter(FILE* out);
unsigned long filecopy(FILE* in,FILE* out);

/*load some files*/
/*converts type values into something the TGA thingy can use
  0 -32bit rgba
  1 -24bit rgb
  2 -16/15bit rgba
  3 -16ci  32bit samples
  4 -16ci  24bit samples
  5 -16ci  16bit samples
  6 -256ci 32bit samples
  7 -256ci 24bit samples
  8 -256ci 16bit samples
  9 -16bit IA (8:8)
  A -8bit IA  (4:4)
  B -4bit IA  (3:1)
  C -8bit I
  D -4bit I
  0x40    flip horizontal
  0x80    flip vertical
  */
int main(int argc, char *argv[])
{FILE *in, *out, *sizes;
char filename[130];
unsigned long size,x=0x20,y,mode,blow;
unsigned short conv,w=0,h=0;
unsigned char suck,hold;

if(argc<3) erratta(75);
if(!(in = fopen(argv[1], "rb"))) erratta(9);
if(sizes = fopen(argv[3], "rb"))
  {y=strtol(argv[4],0,0);
   fseek(sizes,y*4,SEEK_SET);
   fread(&w,2,1,sizes);
   fread(&h,2,1,sizes);
   w/=32;
   h/=32;
   fclose(sizes);
   }

mode=strtol(argv[2],0,0);
strcpy(filename,argv[1]);
strcpy(strstr(filename,".bin"),".tga");
if (!(out = fopen(filename, "wb+"))) erratta(1);

y=mode&0xF;
size=filesize(in);
if(mode&0x80) x^=0x20;
if(mode&0x40) x^=0x10;

if(y==0){/*straight 32bit color*/
         TGAheader(out,0x0200,w,h,0x2008 | x);
         filecopy(in,out);
         }
else if(y==1){/*straight 24bit color*/
         TGAheader(out,0x0200,w,h,0x2000 | x);
         filecopy(in,out);
         }
else if(y==2){/*straight 16bit color*/
         TGAheader(out,0x0200,w,h,0x2008 | x);
         convertimage(in,out);
         }
else if(y==3) erratta(76); /*16ci 32bit color*/
else if(y==4) erratta(76); /*16ci 24bit color*/
else if(y==5){             /*16ci 16bit color*/
         TGAheader(out,0x0200,w,h,0x2008 | x);
         for(x=0x20;x<size;x+=1)
            {fseek(in,x,SEEK_SET); /*grab image value*/
            fread(&suck,1,1,in);
            /*one nibble at a time*/
            fseek(in,(suck>>4) * 2,SEEK_SET);           /*grab palette entry = 2*suck*/
            fread(&conv,2,1,in);
            blow=palette16(shortswap(conv));
            blow=byteswap(blow);
            fwrite(&blow,4,1,out);
            /*last little nibble*/
            suck&= 0x0F;
            fseek(in,suck * 2,SEEK_SET);
            fread(&conv,2,1,in);
            blow=palette16(shortswap(conv));
            blow=byteswap(blow);
            fwrite(&blow,4,1,out);
            }
         }
else if(y==6) erratta(76);      /*256ci 32bit color*/
else if(y==7) erratta(76);      /*256ci 24bit color*/
else if(y==8){                  /*256ci 16bit color*/
         TGAheader(out,0x0200,w,h,0x2008 | x);
         for(x=0x200;x<size;x+=1)
            {fseek(in,x,SEEK_SET); /*grab image value*/
            fread(&suck,1,1,in);
            fseek(in,suck * 2,SEEK_SET);           /*grab palette entry = 2*suck*/
            fread(&conv,2,1,in);
            blow=palette16(shortswap(conv));
            blow=byteswap(blow);
            fwrite(&blow,4,1,out);
            }
         }
else if(y==9){/*16bit IA format - 8bit b/w + 8bit alpha*/
         TGAheader(out,0x0300,w,h,0x1008 | x);
         filecopy(in,out);
         }
else if(y==10){             /*8bit IA*/
         TGAheader(out,0x0300,w,h,0x2800 | x);
         for(x=0;x<size;x+=1)
            {fseek(in,x,SEEK_SET);  /*had a weird problem earlier.  besides, flawless*/
            fread(&hold,1,1,in);
            suck=(hold>>4) & 0xF;
            suck=(suck<<4) | suck;
            fwrite(&suck,1,1,out);  /*color 00-black to FF-white*/
            suck=hold & 0xF;
            suck=(suck<<4) | suck;
            fwrite(&suck,1,1,out);
            }
         }
else if(y==11){            /*4bit IA.  ccca*/
         TGAheader(out,0x0300,w,h,0x2800 | x);
         for(x=0;x<size;x++)
            {fseek(in,x,SEEK_SET);
            fread(&hold,1,1,in);
            suck=(hold>>4) & 0xE;   /*first nibble color*/
            suck++;
            suck=(suck<<4) | suck;
            fwrite(&suck,1,1,out);  /*color 11-nearblack to FF-white*/
            suck=(hold>>4) & 0x1;   /*first nibble alpha*/
            suck*=0xFF;
            fwrite(&suck,1,1,out);
        
            suck=hold & 0xE;        /*second nibble color*/
            suck++;
            suck=(suck<<4) | suck;
            fwrite(&suck,1,1,out);
            suck=hold & 0x1;        /*second nibble alpha*/
            suck*=0xFF;
            fwrite(&suck,1,1,out);
            }
          }
else if(y==12){/*8bit b/w image w/o alpha*/
         TGAheader(out,0x0300,w,h,0x0800 | x);
         filecopy(in,out);
         }
else if(y==13){            /*4bit I*/
         TGAheader(out,0x0300,w,h,0x2800 | x);
         for(x=0;x<size;x+=1)
            {fseek(in,x,SEEK_SET);  /*had a weird problem earlier.  besides, flawless*/
            fread(&suck,1,1,in);
            conv=vartrans(suck>>4);
            conv=shortswap(conv);
            fwrite(&conv,2,1,out);
            conv=vartrans(suck);
            conv=shortswap(conv);
            fwrite(&conv,2,1,out);
            }
         }
else return 1;
    
TGAfooter(out);
fclose(in);
fclose(out);
return 0;
}

/*converts 16bit image to 32bit (ready for Tiff)
at moment, need to swap red and blue component*/
int convertimage(FILE *in,FILE *out)
{unsigned long blow,size,x;
unsigned short suck;

size=filesize(in);
rewind(in);
    for(x=0;x<size;x+=2)
        {fseek(in,x,SEEK_SET);  /*had a weird problem earlier.  besides, flawless*/
        fread(&suck,2,1,in);
        blow=palette16(shortswap(suck));
        blow=byteswap(blow);
        fwrite(&blow,4,1,out);
        }
return 0;}

/*this just applies the header*/
int header(FILE *out,int mode)
{unsigned long y, x;

/*this sets the size of the palette*/
x=0;
y=(4 << mode) + 0x36;
if(mode>=24) y=0x36;

fwrite("BM",2,1,out);
fwrite(&x,4,1,out);
fwrite(&x,4,1,out);
fwrite(&y,4,1,out);
y=0x28;
fwrite(&y,4,1,out);
fwrite(&x,4,1,out);
fwrite(&x,4,1,out);
y=1+(mode << 16);
fwrite(&y,4,1,out);
for(y=0;y<6;y++) fwrite(&x,4,1,out);

return 0;
}    

/*this does a loop, converting to palettes*/
long lupus(FILE *in, FILE *out, int mode)
{unsigned short suck;
unsigned long blow, x;

if(mode>=24) return 0;
mode=2 << mode;

rewind(in);
for(x=0;x<mode;x+=2)
    {fseek(in,x,SEEK_SET);  /*had a weird problem earlier.  besides, flawless*/
    fread(&suck,2,1,in);
    blow=palette16(shortswap(suck));
    blow=byteswap(blow);
    fwrite(&blow,4,1,out);
    }    

return ftell(out);
}    

/*****************************************
vartrans() converts 4bit variably 
transparent images into 32bit white 
source with alpha.

This takes a byte, but expects a nibble.
Only send it a nibble at a time.

You see it a bit with fonts and such.
*****************************************/

unsigned short vartrans(unsigned char org)
{unsigned short out=0xFF00;
 org = org & 0x0F;
 out= out | org | (org<<4);
 return out;
}
/*****************************************
palette16() converts the common 16 color
palettes in N64 games into RGB values,
mostly to insert into BMP images that
are later compressed into PNGs

Anyway, feed it a 16bit palette and you 
get RGB.  Loop to get more than one
******************************************/
unsigned long palette16(unsigned short org)
{unsigned long out=0;
 int x;
 
 /*this sets alpha channel if bit not toggled
 1=visible, 0=invisible alpha color (similar to cursors)*/
 out=(org & 0x0001) * 0xFF;
 org=org >> 1;
 
 /*basic convertion is 5bit color * 8*/
 for(x=3;x>0;x--)
    {out+=(org & 0x001F) << (3+(8*x));
     org=org >> 5;
     } 
return out;
}    

/*this just copies the image
offset to image should already be set
assuming filesize() doesn't screw it up*/
unsigned long image(FILE *in, FILE *out)
{unsigned long size, x;

size=filesize(in) - ftell(in);
fseek(out,0,SEEK_END);

for(x=0;x<size;x++) fputc(fgetc(in),out);

fseek(out,0x22,SEEK_SET);
fwrite(&size,4,1,out);
x=filesize(out);
fseek(out,2,SEEK_SET);
fwrite(&x,4,1,out);

return size;
}    

/****************************************/
/*applies a header to file*/
/****************************************/
int TGAheader(FILE* out, unsigned long mode, unsigned short x, unsigned short y, unsigned short attrib)
{   
#ifdef INTEL
    mode=byteswap(mode);
    attrib=shortswap(attrib);    /*set color mode*/
#else
    x=shortswap(x);
    y=shortswap(y);
#endif
    fwrite(&mode,4,1,out);
    mode=0;
    fwrite(&mode,4,1,out);
    fwrite(&mode,4,1,out);
    fwrite(&x,2,1,out);
    fwrite(&y,2,1,out);
    fwrite(&attrib,2,1,out);
    
return 0;}
/****************************************/
/*applies the footer*/
/****************************************/
int TGAfooter(FILE* out)
{  unsigned long blow=0;
   unsigned char name[18]="TRUEVISION-XFILE.\0";
   
   fwrite(&blow,4,1,out);
   fwrite(&blow,4,1,out);
   fwrite(name,1,0x12,out);
return 0;}

/****************************************/
/*get the size of a file
it happens often enough it might as well be a function
plus, it won't mess with CUR_POS*/
/****************************************/
unsigned long filesize(FILE *in)
{unsigned long cur,end;
cur=ftell(in);
fseek(in,0,SEEK_END);
end=ftell(in);
fseek(in,cur,SEEK_SET);
return end;}

/****************************************/
/*copies contents of file*/
/****************************************/
unsigned long filecopy(FILE* in,FILE* out)
{unsigned long x,y;

x=filesize(in);
rewind(in);
for(y=0;y<x;y++){
   fseek(in,y,SEEK_SET);
   fputc(fgetc(in),out);
   }
return y;}            
