/*Nibble-swapping routine to deal with TWINE's stupid images*/

#include <stdio.h>

/*macros*/

/*global variables and whatnot*/

/*swaps nibbles in byte*/
unsigned char nibswap(unsigned char w)
{return (w>>4) | (w<<4);}

/*swaps nibbles in each byte of infile, shoving into out
  due to excessive seeking, can output into same file*/
unsigned long swapfile(FILE *in,FILE *out,unsigned long pos)
{unsigned long x,y;
unsigned char z;

fseek(in,0,SEEK_END);
x=ftell(in);

for(y=pos;y<x;y++)
   {fseek(in,y,SEEK_SET);
   z=fgetc(in);
   z=nibswap(z);
   fseek(out,y,SEEK_SET);
   fputc(z,out);
   }

return ftell(out);}

/*error codes and stuff*/
long erratta(long code)
{switch(code)
       {case 1: fprintf(stderr,"\nNibble-swapping program\nUsage: NibSwap.exe <filename.ext> {optional: hex offset in file}\n"); break;
        default:fprintf(stderr,"\nAn unknown error occcured.\n");
        }
 return code;}

/*main
  open files and whatnot*/
int main(int argc, char *argv[])
{FILE *in;
unsigned long x=0;

if(argc<2) return(erratta(1));
/*open input and output files*/
if (!(in = fopen(argv[1], "rb+"))) return(erratta(1));

if(argc==3) x=strtol(argv[2],0,0);
swapfile(in,in,x);

/*wrap things up*/
fclose(in);
return 0;}
