#ifndef TWINE
#define TWINE

#include <stdio.h>  /*stupid compiler being ansy*/
#include <stdlib.h>

/*typedefs and global variables*/
#define INTEL            /*define this on intel systems so values are byteswapped*/
#define CORRECT 0x54D910 /*correction value for ROM offsets*/
#define ROMTABLE 0xC1380 /*initial rom address of the rom table*/

typedef union{
        unsigned long l;
        float f;
        } F_L;

/*stage numbers*/
enum{AIR_RAID       =0,
     PM12_DEPARTURE =1,
     COURIER        =2,
     CASTLE         =4,
     ISTANBUL       =7,
     CRATE_YARD     =8,
     FIELD_OF_FIRE  =9,
     MASQUERADE     =0xB,
     FOREST         =0xC,
     THAMES_CHASE   =0x10,
     FALLEN_ANGEL   =0x12,
     MERCHANT       =0x13,
     KINGS_RANSOM   =0x14,
     MI6            =0x15,
     SILO_SURPRISE  =0x16,
     FLASHPOINT     =0x17,
     LABYRINTH      =0x18,
     COLD_RECEPTION =0x19,
     SKY_RAIL       =0x1A,
     TURNCOAT       =0x1C,
     SINKING_FEELING=0x1D,
     FROSTBITE      =0x1F,
     SUBMARINE      =0x20,
     MELTDOWN       =0x21,
     UNDERGROUND    =0x22,
     NIGHT_WATCH    =0x26,
     HIDDEN_VOLCANO =0x27,
     WALKWAYS_II    =0x28,
     WALKWAYS_I     =0x29,
     };

/*macros*/

/*function declarations*/
unsigned long byteswap(unsigned long);
unsigned short int shortswap(unsigned short int);
long erratta(long);

/*functions*/
/*standard 32bit byteswapping*/
unsigned long byteswap(unsigned long w)
{return (w >> 24) | ((w >> 8) & 0x0000ff00) | ((w << 8) & 0x00ff0000) | (w << 24);}    

/*standard 16bit byteswapping*/
unsigned short int shortswap(unsigned short int w)
{return (w >> 8) | (w << 8);}

/*error messages*/
long erratta(long code)
{switch(code)
       {case 1: fprintf(stderr,"\a\nUnable to open output data file"); break;
        case 2: fprintf(stderr,"\a\nUnable to open a temporary file"); break;
        case 3: fprintf(stderr,"\a\nUnable to open object file\nIt must be named 'objects' and in the working directory"); break;
        case 4: fprintf(stderr,"\a\nUnable to open ? file\nIt must be named 'unknown' and in the working directory"); break;
        case 5: fprintf(stderr,"\a\nUnable to open image file\nIt must be named 'img' and in the working directory"); break;
        case 6: fprintf(stderr,"\a\nUnable to open palette file\nIt must be named 'pal' and in the working directory"); break;
        case 7: fprintf(stderr,"\a\nUnable to open image index file\nIt must be named 'iimg' and in the working directory"); break;
        case 8: fprintf(stderr,"\a\nUnable to open palette index file\nIt must be named 'ipal' and in the working directory"); break;
        case 9: fprintf(stderr,"\a\nA base filename must be cited as an argument!"); break;
        case 10:fprintf(stderr,"\a\nUnable to open vertices index\nPlace a corresponding 'filename_v' in the working directory"); break;
        case 11:fprintf(stderr,"\a\nUnable to open RGBA index\nPlace a corresponding 'filename_c' in the working directory"); break;
        case 12:fprintf(stderr,"\a\nUnable to open ST index\nPlace a corresponding 'filename_t' in the working directory"); break;
        case 13:fprintf(stderr,"\a\nUnable to open geometry file\nPlace a corresponding 'filename_g' in the working directory"); break;
        case 14:fprintf(stderr,"\a\nUnable to open rom file"); break;
        /*case : fprintf(stderr,"\a\n"); break;*/
        /*image export errors*/
        case 50: fprintf(stderr,"\a\nYou must cite the rom index of image data,\nfollowed by the numerical offset."); break;
        case 75: fprintf(stderr,"\a\nUsage: N64toTGA.exe <filename.bin> <mode>\n\t0 -32bit rgba\t1 -24bit rgb\t2 -16/15bit rgba\n\t3 -16ci  32bit samples\t4 -16ci  24bit samples\t5 -16ci  16bit samples\n\t6 -256ci 32bit samples\t7 -256ci 24bit samples\t8 -256ci 16bit samples\n\t9 -16bit IA (8:8)\tA -8bit IA  (4:4)\tB -4bit IA  (3:1)\n\tC -8bit I\tD -4bit I\n\t0x40    flip horizontal\t0x80    flip vertical"); break;
        case 76: fprintf(stderr,"\a\nOkay, I lied.\nConversion mode not yet supported."); break;
        /*object export errors*/
        case 100:fprintf(stderr,"\a\nUnknown microcode value"); break;
        case 101:fprintf(stderr,"\a\nReferenced image not found"); break;
        case 102:fprintf(stderr,"\a\nUnable to open image size reference file for material library"); break;
        default:fprintf(stderr,"\a\nUnknown error %i",code); code=0;
        }
if(code) {fprintf(stderr,"\nPress ENTER to quit.");
         getchar(); exit(code);
         }
return code;}

#endif  /*TWINE*/
