/*TWINE telemetry extraction program
  In theory, should extract objects from TWINE (N64)*/
#include <stdio.h>
#include <stdlib.h>
#include "TWINE.h"
#include "TWINEobj.h"

#define DEBUGGERY    /*disallows failure on unknown microcode types*/

int IMGsize(FILE *sizes,unsigned long num,short *width,short *height)
{/*to-do: make this do something functional*/
 fseek(sizes,num*4,SEEK_SET);
 if(feof(sizes)) return 1;
 
 fread(width,2,1,sizes);
 fread(height,2,1,sizes);
 return 0;}

/*parse the geometry microcode*/
int OBJchunk(FILE *in,FILE *mtl,FILE *sizes,short *tex1,short *tex2,FILE *out)
{unsigned long pos,size;
 short width=0,height=0;
 long texnum;
 int x,y,a,b,c,num=0,mtlnum=1;
 unsigned short vert[3][256];            /*max number of vertices*/
 
 memset(vert,0,702);
 
 fseek(in,0,SEEK_END);
 size=ftell(in);
 for(pos=0;pos<size;)  /*always increments for command type*/
    {fseek(in,pos,SEEK_SET);
     x=fgetc(in);
     a=1;
     switch(x)
           {case 2:         /*16bit vertex list - geometry only*/
                 a++;
            case 3:         /* 8bit vertex list - geometry only*/
                 a++;
            case 1:         /*16bit vertex list*/
                 a++;
            case 0:         /* 8bit vertex list*/
                 /*loot the values, then determine sign!*/            
                 Object(out,num);
                 texnum=fgetc(in);
                 pos+=2;
                 for(x=0;x<texnum;x++)
                    {fseek(in,pos,SEEK_SET);
                     vert[0][x]=0; vert[1][x]=0; vert[2][x]=0;
                     for(b=0;b<a&1;b++)
                        {vert[0][x]=vert[0][x]<<8;
                         c=fgetc(in);
                         vert[0][x]|=c;
                         pos++;
                         }
                     if(a&2) continue;
                     for(b=0;b<a&1;b++)
                        {vert[1][x]=vert[1][x]<<8;
                         c=fgetc(in);
                         vert[1][x]|=c;
                         pos++;
                         }
                     for(b=0;b<a&1;b++)
                        {vert[2][x]=vert[2][x]<<8;
                         c=fgetc(in);
                         vert[2][x]|=c;
                         pos++;
                         }
                     }
                 num++;
                 break;
           case 8:    /*gaussian triangles - form a new material for this purpose*/
           case 9:    /*set gaussian only*/
                 a=fgetc(in);
                 b=fgetc(in);
                 c=fgetc(in);
                 fprintf(mtl,"\n");
                 NewMtlL(mtl,mtlnum);
                 LightDif(mtl,a/256,b/256,c/256);
                 LightAmb(mtl,a/256,b/256,c/256);
                 LightSpe(mtl,a/256,b/256,c/256);
                 MaterialL(out,mtlnum);
                 mtlnum++;
                 pos+=3;
                 if(x==9)
                   {pos++;
                    break;}
            case 7:    /*textured triangles -  8bit index*/
            case 6:    /*textured triangles - 16bit index*/
            case 10:   /*set texture only   -  8bit index*/
                 if(x!=8)
                   {if(x==6)
                      {fread(&width,2,1,in);
#ifdef INTEL
                       width=shortswap(width);
#endif
                       y=width;
                       pos++;
                       }
                    else y=fgetc(in);
                    Material(out,y);
                    /*get the width and height of the image, from the image*/
                    if(IMGsize(sizes,y,&width,&height))
                      {fprintf(stderr,"\nimage not found - faking it");
                      width=0; height=0;}
                    /*to-do: get accurate coordinates, not this faked stuff*/
                    if(width>0 && height>0) {for(y=0;y<texnum;y++) TexVert(out,tex1[vert[1][y]]/width,tex2[vert[1][y]]/height);}
                    pos++;
                    }
                 if(x==10) 
                   {pos++;
                    break;}
            case 5:    /*basic triangles*/
                 if(x==5 && num<2) MaterialL(out,0);

                 y=fgetc(in);
                 pos+=2;
                 for(x=0;x<y;x++)
                    {fseek(in,pos,SEEK_SET);
                     a=fgetc(in);
                     b=fgetc(in);
                     c=fgetc(in);
                     pos+=3;
                     if(width) TFace(out,vert[0][a]+1,vert[0][b]+1,vert[0][c]+1,a-texnum,b-texnum,c-texnum);
                     else Face(out,vert[0][a]+1,vert[0][b]+1,vert[0][c]+1);
                     }
                 break;
            case 4:    /*single, basic triad*/
                 if(num<2) MaterialL(out,0);
                 pos++;
                 fseek(in,pos,SEEK_SET);
                 a=fgetc(in);
                 b=fgetc(in);
                 c=fgetc(in);
                 pos+=3;
                 if(width) TFace(out,vert[0][a]+1,vert[0][b]+1,vert[0][c]+1,a-texnum,b-texnum,c-texnum);
                 else Face(out,vert[0][a]+1,vert[0][b]+1,vert[0][c]+1);
                 break;
            case 11:
                 pos+=2;
#ifdef DEBUGGERY
                 fprintf(stderr,"\a\nCongratulations!\n\tUnknown microcode value %X @ 0x%X\n\tlet me know, okay?\n\t-press ENTER to continue-",x,pos);
                 getchar();
#endif
                 break;
            case 12:
                 return mtlnum;
            default:
#ifdef DEBUGGERY
                 fprintf(stderr,"\a\nUnknown microcode value %X @ 0x%X",x,pos);
#else
                 erratta(100);
#endif
            }/*end switch*/
     
     
     }/*end parse microcode*/
 
 return mtlnum;}

/*processes the geometry chunk
  returns #entries*/
unsigned long WriteVertices(FILE *in,float xpos,float ypos,float zpos,FILE *out)
{unsigned long x,size;
 F_L buf[3];
 
 Rem(out,Master Vertex List);

 fseek(in,0,SEEK_END);
 size=ftell(in);
 for(x=0;x<size;x+=12)
    {fseek(in,x,SEEK_SET);
     fread(buf,4,3,in);
#ifdef INTEL
     buf[0].l=byteswap(buf[0].l);
     buf[1].l=byteswap(buf[1].l);
     buf[2].l=byteswap(buf[2].l);
#endif
     Vertex(out,buf[0].f+xpos,buf[1].f+ypos,buf[2].f+zpos);
     }
 
 return (size/12);}

/*fills the texture coordinate table with...stuff
  returns #entries*/
unsigned long FillSTTable(FILE *in,short *tex1,short *tex2)
{unsigned long x,size;
 unsigned short y;
 
 fseek(in,0,SEEK_END);
 size=ftell(in);
 for(x=0;x<size;x+=4)
    {fseek(in,x,SEEK_SET);
     fread(&y,2,1,in);
#ifdef INTEL
     y=shortswap(y);
#endif
     tex1[x/4]=y;
     fread(&y,2,1,in);
#ifdef INTEL
     y=shortswap(y);
#endif
     tex2[x/4]=y;     
     }
 
 return (size/4);}

/*main
  open files and whatnot*/
int main(int argc, char *argv[])
{char filename[130];
FILE *obj,*mtl,*vtx,*tex,*rgb,*geo,*size;
unsigned long x,num=0;
short table[2][256];      /*this should do pig - safer than allocation*/
float xpos=0.0,ypos=0.0,zpos=0.0;

/*open input and output files*/
if(argc<2) erratta(9);
sprintf(filename,"%s.obj",argv[1]);
while (obj = fopen(filename, "rt")) 
      {num++;
      sprintf(filename,"%s%i.obj",argv[1],num);
      }
if(!(obj = fopen(filename,"wt"))) erratta(9);

if(num<1) sprintf(filename,"%s.mtl",argv[1]);
else sprintf(filename,"%s%i.mtl",argv[1],num);
/*material file*/
while (!(mtl = fopen(filename, "wt"))) {
      printf("\nname of corresponding material file? (.mtl)");
	  strcpy(filename,"\0");	
	  gets(filename);
      }

/*prep output file*/
Rem(obj,TWINE Telemetry Extraction Program);
Rem(obj,c/o Zoinkity (nefariousdogooder@yahoo.com));
MtlLib(obj,filename);
if(argc>2) {sprintf(filename,"%s.mtl",argv[2]);
           MtlLib(obj,filename);
           sprintf(filename,"%s.bin",argv[2]);
           if(!(size=fopen(filename,"rb"))) erratta(102);
           }
Rem(mtl,TWINE Telemetry Extraction Program - Local Material File);
Rem(mtl,c/o Zoinkity (nefariousdogooder@yahoo.com));
NewMtlL(mtl,0);
LightDif(mtl,0,0,0);
LightAmb(mtl,0,0,0);
LightSpe(mtl,0,0,0);

sprintf(filename,"%s_v",argv[1]);
if(!(vtx=fopen(filename,"rb"))) erratta(10);
sprintf(filename,"%s_c",argv[1]);
if(!(rgb=fopen(filename,"rb"))) erratta(11);
sprintf(filename,"%s_t",argv[1]);
if(!(tex=fopen(filename,"rb"))) erratta(12);
sprintf(filename,"%s_g",argv[1]);
if(!(geo=fopen(filename,"rb"))) erratta(13);


if(argc>3) xpos=strtof(argv[3],0);
if(argc>4) ypos=strtof(argv[4],0);
if(argc>5) zpos=strtof(argv[5],0);

/*write a full list of vertices - used by everything*/
WriteVertices(vtx,xpos,ypos,zpos,obj);

/*create the materials for each vertex*/
/*to-do*/

/*create a texture coordinate master list*/
FillSTTable(tex,table[0],table[1]);

/*parse the geometry microcode*/
OBJchunk(geo,mtl,size,table[0],table[1],obj);

/*wrap things up*/
fclose(size);
fclose(mtl);
fclose(obj);
fclose(vtx);
fclose(rgb);
fclose(tex);
fclose(geo);
return 0;}
