#ifndef TWINE_OBJ
#define TWINE_OBJ

#include <stdio.h>  /*stupid compiler being ansy*/
#include <stdlib.h>

/*typedefs and global variables*/

/*function declarations*/

/*macros*/
/*these are commands used in wavefront objects.  I'm lazy and don't write them completely*/
/*writes a comment*/
#define Rem(F,T)                fprintf(F,"# T\n")
/*writes a vertex*/
#define Vertex(F,FX,FY,FZ)      fprintf(F,"v %f %f %f\n",(float)FX,(float)FY,(float)FZ)
/*writes texture values*/
#define TexVert(F,FX,FY)        fprintf(F,"vt %f %f\n",(float)FX,(float)FY)
/*writes normal values*/
#define NormVert(F,FX,FY)       fprintf(F,"vn %f %f\n",(float)FX,(float)FY)
/*writes a point*/
#define Point(F,V)              fprintf(F,"p %i\n",V)
/*writes a line*/
#define TLine(F,X,Y,TX,TY)      fprintf(F,"l %i/%i %i/%i\n",X,TX,Y,TY)
#define Line(F,X,Y)             fprintf(F,"l %i %i\n",X,Y)
/*writes a face command to file*/
#define TFace(F,X,Y,Z,TX,TY,TZ) fprintf(F,"f %i/%i %i/%i %i/%i\n",X,TX,Y,TY,Z,TZ)
#define Face(F,X,Y,Z)           fprintf(F,"f %i %i %i\n",X,Y,Z)
/*sets an object name*/
#define Object(F,V)             fprintf(F,"o obj%i\n",V)
/*sets the texture*/
#define TexLib(F,N)             fprintf(F,"maplib %s\n",N)
#define Texture(F,V)            fprintf(F,"usemap tex%i\n",V)
/*sets the material applied*/
#define MtlLib(F,N)             fprintf(F,"mtllib %s\n",N)
#define NoMtl(F)                fprintf(F,"usemtl off\n",V)
#define Material(F,V)           fprintf(F,"usemtl mtl%i\n",V)
#define MaterialL(F,V)          fprintf(F,"usemtl local%i\n",V)
/*other render attributes*/
#define Shadow(F,N)             fprintf(F,"shadow_obj %s\n",N)
#define Reflect(F,N)            fprintf(F,"trace_obj %s\n",N)
#define LOD(F,V)                fprintf(F,"lod %i\n",V)
#define Bevel(F,V)              fprintf(F,"bevel %s\n",V>0 ? "off":"on")
#define Color(F,V)              fprintf(F,"c_interp %s\n",V>0 ? "off":"on")
#define Alpha(F,V)              fprintf(F,"d_interp %s\n",V>0 ? "off":"on")
/*other commands*/
#define Call(F,N)               fprintf(F,"call N\n")

/*macros for constructing material libraries*/
#define NewMtl(F,V)             fprintf(F,"newmtl mtl%i\n",V)
#define NewMtlL(F,V)            fprintf(F,"newmtl local%i\n",V)
#define ImgDif(F,V,I,E)         fprintf(F,"map_Kd %X_%i.%s\n",V,I,E)
#define ImgAmb(F,V,I,E)         fprintf(F,"map_Ka %X_%i.%s\n",V,I,E)
#define ImgSpe(F,V,I,E)         fprintf(F,"map_Ks %X_%i.%s\n",V,I,E)
#define ImgNs(F,V,I,E)          fprintf(F,"map_Ns %X_%i.%s\n",V,I,E)
#define ImgA(F,V,I,E)           fprintf(F,"map_d %X_%i.%s\n",V,I,E)
#define LightDif(F,FX,FY,FZ)    fprintf(F,"Kd %f %f %f\n",(float)FX,(float)FY,(float)FZ)
#define LightAmb(F,FX,FY,FZ)    fprintf(F,"Ka %f %f %f\n",(float)FX,(float)FY,(float)FZ)
#define LightSpe(F,FX,FY,FZ)    fprintf(F,"Ks %f %f %f\n",(float)FX,(float)FY,(float)FZ)
#define Diffuse(F,FV)           fprintf(F,"d %f\n",(float)FV)
#define Transmit(F,FV)          fprintf(F,"Tf %f %f %f\n",(float)FX,(float)FY,(float)FZ)
#define Illum(F,V)              fprintf(F,"illum %i\n",V)
enum{ColorAmbientOff=0,
     ColorAmbientOn,
     Highlight,
     ReflectRayTrace,
     GlassRayTrace,
     FresnelRayTrace,
     RefractRayTrace,
     RefractFresnelRayTrace,
     Reflect,
     Glass,
     CastShadows
     };
#define Specular(F,E)           fprintf(F,"Ns %i\n",E)         /*0-1000*/
#define Density(F,FV)           fprintf(F,"Ni %f\n",(float)FV) /*0.001-10*/
#define Sharp(F,V)              fprintf(F,"sharpness %i\n",V)  /*0-1000*/
#define Alias(F,V)              fprintf(F,"map_aat %s\n",V>0 ? "off":"on")


/*functions*/

#endif  /*TWINE_OBJ*/
