/*TWINE telemetry extraction program
  In theory, should extract objects from TWINE (N64)*/
#define INTEL       /*define this on intel systems so values are byteswapped*/

#include <stdio.h>
#include <stdlib.h>
#include "TWINE.h"
#include "BATCH.h"

/*macros*/

/*global variables and whatnot*/
enum {CLEAN        =1,
      IMGOUT       =2,
      GEOOUT       =4,
      NOWAVEFRONT  =16,
      NON64DL      =32,
      ABS_POS      =64,
      EXEC         =128,
      TARGA        =256,
      };


/*extract level resources*/
int extracto(FILE *in,FILE *batch,unsigned long pos)
{unsigned long x,y,z;
 unsigned char buf[3],filename[20];
 FILE *data;
 
 pos+=CORRECT; /*corrects file position*/
 
 for(x=0;x<2;x++)              /*6 extracts image and palettes*/
    {fseek(in,pos,SEEK_SET);   /*get the offset to chunk of data*/
    fread(&y,4,1,in);
    fread(&z,4,1,in);
#ifdef INTEL
    y=byteswap(y);
    z=byteswap(z);
#endif
    pos+=8;
    if(y==0) continue;
    
    /*generate string name for file and open it*/
    switch(x)
          {case 0: strcpy(filename,"objects\0");
                z*=68; 
                break;
           case 1: strcpy(filename,"unknown\0");
                z*=28;
                break;
           case 2: strcpy(filename,"ipal\0");
                z*=8;
                break;
           case 3: strcpy(filename,"iimg\0");
                z*=12;
                break;
           case 4: strcpy(filename,"pal\0"); break;
           case 5: strcpy(filename,"img\0"); break;
           default: continue;
           }
    if(!(data=fopen(filename,"wb+"))) erratta(1);
    
    /*extract data*/
    y+=CORRECT;
    fseek(in,y,SEEK_SET);
    for(y=0;y<z;y++) fputc(fgetc(in),data);

    /*determine if data is compressed*/
    fseek(data,0,SEEK_SET);
    fread(buf,1,3,data);
    fclose(data);
    if(!(strncmp(buf,"EDL",3))) DECOMP(batch,filename);/*write decompression note in batch file*/
    }
 
 return 0;}

unsigned long HappyEntry(FILE *rom,unsigned long num)
{fseek(rom,ROMTABLE+num*16,SEEK_SET);
 fread(&num,4,1,rom);
#ifdef INTEL
 num=byteswap(num);
#endif
 return num;}

/*main
  open files and whatnot*/
int main(int argc, char *argv[])
{char filename[130],buf[30];
FILE *in,*list,*out;
unsigned long x,num=LABYRINTH,flag=0;

/*default settings*/
flag=CLEAN | IMGOUT | GEOOUT | NON64DL | EXEC;

for(x=1;x<argc;x++)/*command-line arguments*/
    {if(argv[x][0]=='-' || argv[x][0]=='/')
      {switch(argv[x][1])
             {case 'S': case 's': 
                   strcpy(buf,argv[x]+2);
                   if(!strncasecmp(buf,"Air",3))              num=AIR_RAID;
                   else if(!strncasecmp(buf,"Midnight",8))    num=PM12_DEPARTURE;
                   else if(!strncasecmp(buf,"Courier",7))     num=COURIER;
                   else if(!strncasecmp(buf,"Castle",6))      num=CASTLE;
                   else if(!strncasecmp(buf,"Istanbul",8))    num=ISTANBUL;
                   else if(!strncasecmp(buf,"Crate",5))       num=CRATE_YARD;
                   else if(!strncasecmp(buf,"Field",5))       num=FIELD_OF_FIRE;
                   else if(!strncasecmp(buf,"Masquerade",10)) num=MASQUERADE;
                   else if(!strncasecmp(buf,"Forest",6))      num=FOREST;
                   else if(!strncasecmp(buf,"Thames",6))      num=THAMES_CHASE;
                   else if(!strncasecmp(buf,"Fallen",6))      num=FALLEN_ANGEL;
                   else if(!strncasecmp(buf,"Merchant",8))    num=MERCHANT;
                   else if(!strncasecmp(buf,"King",4))        num=KINGS_RANSOM;
                   else if(!strncasecmp(buf,"MI6",3))         num=MI6;
                   else if(!strncasecmp(buf,"Silo",4))        num=SILO_SURPRISE;
                   else if(!strncasecmp(buf,"Flashpoint",10)) num=FLASHPOINT;
                   else if(!strncasecmp(buf,"Labyrinth",9))   num=LABYRINTH;
                   else if(!strncasecmp(buf,"Cold",4))        num=COLD_RECEPTION;
                   else if(!strncasecmp(buf,"Sky",3))         num=SKY_RAIL;
                   else if(!strncasecmp(buf,"Turncoat",8))    num=TURNCOAT;
                   else if(!strncasecmp(buf,"Sink",4))        num=SINKING_FEELING;
                   else if(!strncasecmp(buf,"Frostbite",9))   num=FROSTBITE;
                   else if(!strncasecmp(buf,"Submarine",9))   num=SUBMARINE;
                   else if(!strncasecmp(buf,"Meltdown",8))    num=MELTDOWN;
                   else if(!strncasecmp(buf,"Under",5))       num=UNDERGROUND;
                   else if(!strncasecmp(buf,"Night",5))       num=NIGHT_WATCH;
                   else if(!strncasecmp(buf,"Hidden",6))      num=HIDDEN_VOLCANO;
                   else if(!strncasecmp(buf,"Walkways2",9))   num=WALKWAYS_II;
                   else if(!strncasecmp(buf,"Walkways1",9))   num=WALKWAYS_I;
                   else num=strtol(buf,0,0);
                   break;
              case 'C': case 'c': flag^=CLEAN;      break;
              case 'G': case 'g': flag^=GEOOUT;     break;
              case 'I': case 'i': flag^=IMGOUT;     break;
              case 'N': case 'n': flag^=NOWAVEFRONT;break;
              case 'O': case 'o': flag^=NON64DL;    break;
              case 'A': case 'a': flag^=ABS_POS;    break;
              case 'E': case 'e': flag^=EXEC;       break;
              case 'T': case 't': flag|=TARGA;      break;
              case 'B': case 'b': flag&=!TARGA;     break;
              /*case '': case '': break;*/
              case 'H': case 'h': case '?':
                  printf("\nTWINE (N64) telemetry extraction program");
                  printf("\n  /S<#> or -S<#>\tgrab stage <#> or <name>");
                  printf("\n  /C or -C\tdo not clean extracted files");
                  printf("\n  /E or -E\tdon't execute the batch file");
                  printf("\n  /I or -I\tdo not process images");
                  printf("\n  /G or -G\tdo not process geometry");
                  printf("\n  /T or -T\timages: produce targas (.tga)");
                  printf("\n  /O or -O\tgeometry: do not produce wavefront objs");
                  printf("\n  /N or -N\tgeometry: do not produce N64 display lists");
                  printf("\n  /A or -A\tgeometry: use absolute, not relative, positions");
                  printf("\n  /H, -H, or -?\tdisplay this help message");
                  printf("\n\n\tPress -enter- to quit\n"); getchar(); return 0;
              }    
      }
    else strcpy(filename,argv[x]);
    }/*end command-line arguments*/

/*open input and output files*/
while (!(in = fopen(filename, "rb"))) {
    printf("\ninput binary filename? ");
	strcpy(filename,"\0");	
	gets(filename);
    }

strcat(filename,".bat");
while (!(out = fopen(filename, "wt"))) {
      printf("\noutput batch file? (.bat)");
	  strcpy(filename,"\0");	
	  gets(filename);
      }

/*set up batch file*/
ECHO(out,0);
VERIFY(out,EDLdec.exe,baddec);
if(flag&IMGOUT) VERIFY(out,TWImages.exe,noimgs);
if(flag&GEOOUT) VERIFY(out,TWelemetry.exe,noprog);
fprintf(out,"Echo Preparing files...\n\n");

/*extract resources*/
x=HappyEntry(in,num);
extracto(in,out,x);
fclose(in);

/*write command, then end batch file*/
strcpy(strstr(filename,".bat"),"\0");
if(flag&IMGOUT) {fprintf(out,"Echo Processing images...\nStart /W TWImages.exe %s%s%s\n",filename,flag&CLEAN ? "":" -C",flag&TARGA ? " -T":"");
           VERIFY(out,images.bat,nofile);
           fprintf(out,"CALL images.bat\n\n");
           }
if(flag&GEOOUT) {VERIFY(out,objects,nofile);   /*output geometry*/
           fprintf(out,"Echo Processing telemetry...\nStart /W TWelemetry.exe %s%s%s%s%s\n",filename,flag&NON64DL ? "":" -1",flag&NOWAVEFRONT ? "":" -2",flag&ABS_POS ? " -A":"",flag&CLEAN ? "":" -C");
           VERIFY(out,geometry.bat,nofile);
           fprintf(out,"CALL geometry.bat\n\n");
           }
fprintf(out,"Goto fin\n\n");

ERROR(out,baddec,Unable to find EDLdec.exe to decompress file(s));
ERROR(out,noimgs,Unable to find program TWImages.exe);
ERROR(out,noprog,Unable to find program TWelemetry.exe);
ERROR(out,nofile,Failure to locate file(s));
fprintf(out,":fin\n");
if(flag&CLEAN) 
  {fprintf(out,"DEL /F *.bat\n");
   ERASE(out,objects);
   ERASE(out,unknown);
   }
fprintf(out,":end\nEcho All done.\nExit\n");                           /*EOF*/

/*wrap things up*/
fclose(out);
if(flag&EXEC) {strcat(filename,".bat");
      system(filename);
      if(flag&CLEAN)
        {system("DEL /F *.bat");
         system("IF EXIST objects DEL /F objects");
         system("IF EXIST unknown DEL /F unknown");
         }
      }
return 0;}
