/*TWINE telemetry extraction program
  In theory, should extract objects from TWINE (N64)
  These can then be decompressed and assembled by other programs*/
#include <stdio.h>
#include <stdlib.h>
#include "TWINE.h"
#include "BATCH.h"

/*macros*/

/*extract object data header and its data*/
unsigned long OBJchunk(FILE *in,unsigned long pos,FILE *bat)
{unsigned long x,size;
 unsigned short y;
 unsigned char buf[30],edl[3];
 FILE *data;
 
 /*grab vertices*/
 sprintf(buf,"%X_v",pos);
 fseek(in,pos+CORRECT,SEEK_SET);
 fread(&x,4,1,in);
 fread(&y,2,1,in);
#ifdef INTEL
 x=byteswap(x);
 y=shortswap(y);
#endif
 size=y*12;
 x+=CORRECT;
 fseek(in,x,SEEK_SET);  /*detect EDL files*/
 fread(edl,3,1,in);
 if(!(strncmp(edl,"EDL",3)))
   {fseek(in,x+4,SEEK_SET);
    fread(&size,4,1,in);
#ifdef INTEL
    size=byteswap(size);
#endif
    DECOMP(bat,buf);
    }
 if(!(data=fopen(buf,"wb"))) return 1;      /*copy data to file*/
 for(fseek(in,x,SEEK_SET);size>0;size--) fputc(fgetc(in),data);
 fclose(data);

 /*grab RGBA*/
 sprintf(buf,"%X_c",pos);
 fseek(in,pos+CORRECT+8,SEEK_SET);
 fread(&x,4,1,in);
 fread(&y,2,1,in);
#ifdef INTEL
 x=byteswap(x);
 y=shortswap(y);
#endif
 size=y*4;
 x+=CORRECT;
 fseek(in,x,SEEK_SET);  /*detect EDL files*/
 fread(edl,3,1,in);
 if(!(strncmp(edl,"EDL",3)))
   {fseek(in,x+4,SEEK_SET);
    fread(&size,4,1,in);
#ifdef INTEL
    size=byteswap(size);
#endif
    DECOMP(bat,buf);
    }
 if(!(data=fopen(buf,"wb"))) return 1;      /*copy data to file*/
 for(fseek(in,x,SEEK_SET);size>0;size--) fputc(fgetc(in),data);
 fclose(data);
 
 
 /*grab ST*/
 sprintf(buf,"%X_t",pos);
 fseek(in,pos+CORRECT+16,SEEK_SET);
 fread(&x,4,1,in);
 fread(&y,2,1,in);
#ifdef INTEL
 x=byteswap(x);
 y=shortswap(y);
#endif
 size=y*4;
 x+=CORRECT;
 fseek(in,x,SEEK_SET);  /*detect EDL files*/
 fread(edl,3,1,in);
 if(!(strncmp(edl,"EDL",3)))
   {fseek(in,x+4,SEEK_SET);
    fread(&size,4,1,in);
#ifdef INTEL
    size=byteswap(size);
#endif
    DECOMP(bat,buf);
    }
 if(!(data=fopen(buf,"wb"))) return 1;      /*copy data to file*/
 for(fseek(in,x,SEEK_SET);size>0;size--) fputc(fgetc(in),data);
 fclose(data);
 
 /*grab geometry microcode*/
 sprintf(buf,"%X_g",pos);
 fseek(in,pos+CORRECT+24,SEEK_SET);
 fread(&x,4,1,in);
 fread(&y,2,1,in);
#ifdef INTEL
 x=byteswap(x);
 y=shortswap(y);
#endif
 size=y;
 x+=CORRECT;
 fseek(in,x,SEEK_SET);  /*detect EDL files*/
 fread(edl,3,1,in);
 if(!(strncmp(edl,"EDL",3)))
   {fseek(in,x+4,SEEK_SET);
    fread(&size,4,1,in);
#ifdef INTEL
    size=byteswap(size);
#endif
    DECOMP(bat,buf);
    }
 if(!(data=fopen(buf,"wb"))) return 1;      /*copy data to file*/
 for(fseek(in,x,SEEK_SET);size>0;size--) fputc(fgetc(in),data);
 fclose(data);
 
 return 0;}


/*main
  open files and whatnot*/
int main(int argc, char *argv[])
{char filename[130];
FILE *rom,*out,*obj;
unsigned long x,y,loc,end,flag=7;
F_L xpos,ypos,zpos;

for(x=1;x<argc;x++)/*command-line arguments*/
    {if(argv[x][0]=='-' || argv[x][0]=='/')
      {switch(argv[x][1])
             {case '1': flag^=2; break;
              case '2': flag^=4; break;
              case 'C': case 'c': flag^=1; break;
              case 'A': case 'a': flag^=8; break;
              case 'H': case 'h': case '?':
                  printf("\nTWINE (N64) object telemetry extraction program");
                  printf("\n  /1\tdisable wavefront obj postprocessing");
                  printf("\n  /2\tdisable N64 display list postprocessing");
                  printf("\n  /C or -C\tdo not clean files after postprocessing");
                  printf("\n  /A or -A\tuse absolute, not relative positions in postprocessing");
                  printf("\n  /H, -H, or -?\tdisplay this help message");
                  printf("\n\n\tPress -enter- to quit\n"); getchar(); return 0;
              }    
      }
    else strcpy(filename,argv[x]);
    }/*end command-line arguments*/

/*open input and output files*/
while (!(rom = fopen(filename, "rb"))) {
    printf("\ninput binary filename? ");
	strcpy(filename,"\0");	
	gets(filename);
    }

strcpy(filename,"geometry.bat");
while (!(out = fopen(filename, "wt"))) {
      printf("\noutput geometry batch file? (.bat)");
	  strcpy(filename,"\0");	
	  gets(filename);
      }

if(!(obj=fopen("objects","rb"))) erratta(3);

/*set the leader in the batch file*/
ECHO(out,0);
VERIFY(out,EDLdec.exe,noprog);
if(flag&2) VERIFY(out,TWINEobj.exe,noprog);
if(flag&4) VERIFY(out,TWINEdle.exe,noprog);

/*loop extraction for each object*/
fseek(obj,0,SEEK_END);
end=ftell(obj);
for(loc=0;loc<end;loc+=0x44)
   {fseek(obj,loc+0x24,SEEK_SET);
    fread(&x,4,1,obj);
    fread(&y,4,1,obj);
#ifdef INTEL
    x=byteswap(x);
    y=byteswap(y);
#endif
    if(OBJchunk(rom,x,out)) continue;
    /*determine the image library to use*/
    y-=0x800C2740;
    y*=8;
    fseek(rom,0xC1380+y,SEEK_SET);
    fread(&y,4,1,rom);
#ifdef INTEL
    y=byteswap(y);
#endif
    /*determine object position*/
    if(flag&8)
      {fseek(obj,loc+0xC,SEEK_SET);
       fread(&xpos.l,4,1,obj);
       fread(&ypos.l,4,1,obj);
       fread(&zpos.l,4,1,obj);
#ifdef INTEL
       xpos.l=byteswap(xpos.l);
       ypos.l=byteswap(ypos.l);
       zpos.l=byteswap(zpos.l);
#endif
       }
    else {xpos.f=0.0;ypos.f=0.0;zpos.f=0.0;}
    /*write a usage line to batch file*/
    if(flag&2) fprintf(out,"START /W TWINEobj.exe %X %X %f %f %f\n",x,y,xpos.f,ypos.f,zpos.f);
    if(flag&4) fprintf(out,"START /W TWINEdle.exe %X %X\n",x,y);
    fprintf(out,"\n");
    }/*end obj table parsing*/

/*wrap things up*/
if(flag&1) {ERASE(out,*_v);
            ERASE(out,*_t);
            ERASE(out,*_c);
            ERASE(out,*_g);
            }
fprintf(out,"Goto end\n\n");
ERROR(out,noprog,Unable to find program(s));
fprintf(out,":end\nExit\n");
fclose(rom);
fclose(obj);
fclose(out);
return 0;}
